Option Explicit

Function AddCaret$ (strCaretString As String)
'-- This function translates caret codes in a string into ascii characters.
    
    Dim strChar As String
    Dim strTemp As String
    Dim iCharVal As Integer
    Dim iCount As Integer

    For iCount = 1 To Len(strCaretString)
        strChar = Mid$(strCaretString, iCount, 1)
        iCharVal = Asc(UCase$(strChar))
        If iCharVal < 32 And iCharVal > 0 Then
            strTemp = strTemp & "^" & Chr$(iCharVal + 64)
        Else
            strTemp = strTemp & strChar
        End If
    Next
    
    AddCaret$ = strTemp

End Function

Sub Pause (sngSecs As Single)
'-- Pauses for a number of seconds (or fractions of a second).
    
    Dim sngStart As Single
    Dim sngEndTime As Single

    '-- Stamp the time and calculate End Time
    sngStart = Timer
    sngEndTime = sngStart + sngSecs
    If sngStart > Timer Then
        '-- Adjust for Midnight
        sngEndTime = sngEndTime - 24 * 60 * 60
    End If
    
    '-- Pause
    Do
        DoEvents
    Loop Until Timer >= sngEndTime
    
End Sub

Function RemoveCaret$ (strCaretString As String)
'-- Translates iCaret codes into ascii characters
    
    Dim iCaret As Integer
    Dim strTemp As String
    Dim strChar As String
    Dim iLenStr As Integer

    Do
        iCaret = InStr(strCaretString, "^")
        iLenStr = Len(strCaretString)
        If iCaret Then
            If iCaret < iLenStr Then
                strChar = Chr$(Asc(Mid$(strCaretString, iCaret + 1, 1)) - 64)
                strTemp = Left$(strCaretString, iCaret - 1) & strChar
                If iCaret + 2 <= iLenStr Then
                    strTemp = strTemp & Mid$(strCaretString, iCaret + 2)
                End If
                strCaretString = strTemp
            End If
        Else
            Exit Do
        End If
    Loop
    
    RemoveCaret$ = strCaretString

End Function

Function WaitFor$ (Comm1 As Control, strWait As String, iTimeout As Integer, iCDFlag As Integer)
'**********************************************************************************************
' WaitFor$ Copyright 1994 by Carl Franklin. CIS:70662,2605
'
' This routine waits for a specific character or string to be received over
' an open comm port, and returns everything that was received.

'**********************************************************************************************
'
' Arguments:
'
'   Comm1       Specifies the MSCOMM control.
'   strWait     Specifies the string or character to wait for.
'   iTimeout    Specifies the number of seconds to wait.
'   iCDFlag     Specifies whether or not to return if carrier is lost (True or False).
'
' Return Values:
'
'   WaitFor$    Returns all characters received since WaitFor was called.
'   iTimeout    Returns True if WaitFor timed out.
'   iCDFlag     Returns True if carrier detect went low (and CDFlag was passed as True).
'
'**********************************************************************************************
' Local Variables:

    Dim iRT As Integer
    Dim iThere As Integer
    Dim sngStart As Single
    Dim sngEndTime As Single
    Dim strIn As String
    
    '-- Turn Off RThreshold if it is set
    iRT = Comm1.RThreshold
    If iRT Then
        Comm1.RThreshold = 0
    End If

    '-- Set InputLen to 1 (read 1 character with each Input)
    Comm1.InputLen = 1
    
    sngStart = Timer
    '-- Check for time to wrap around midnight
    If Timer + iTimeout > 86400 Then
        sngEndTime = iTimeout - (86400 - Timer)
    Else
        sngEndTime = sngStart + iTimeout
    End If
    
    '-- Main loop
    Do
        '-- Check Carrier
        If iCDFlag Then
            If Comm1.CDHolding = False Then
                iCDFlag = True
                iTimeout = False
                WaitFor$ = strIn$
                Exit Do
            End If
        End If

        '-- Are we out of time
        If Timer >= sngEndTime Then
            iCDFlag = False
            iTimeout = True
            WaitFor$ = strIn$
            Exit Do
        End If
        
        '-- Have we received any data?
        If Comm1.InBufferCount Then
            '-- Get the data
            strIn$ = strIn$ & Comm1.Input
            
            '-- Did we get what we're waiting for?
            iThere = InStr(strIn$, strWait)
            If iThere Then
                iTimeout = False
                iCDFlag = False
                WaitFor$ = strIn$
                Exit Do
            End If
            
            '-- Is strIn$ getting too big?
            If Len(strIn$) > 32000 Then
                '-- Trim it
                strIn$ = Right$(strIn$, Len(strWait))
            End If
        End If

        '-- If you don't call DoEvents, the computer
        '   will lock right up.
        DoEvents
        
    Loop

    '-- Reset RThreshold
    If iRT Then
        Comm1.RThreshold = iRT
    End If
    
End Function

